libgimpprint API Reference: dither-ed.c File Reference

Main Page | Modules | Alphabetical List | Data Structures | File List | Data Fields | Globals | Related Pages

# src/main/dither-ed.c File Reference

`#include <gimp-print/gimp-print.h>`
`#include "gimp-print-internal.h"`
`#include <gimp-print/gimp-print-intl-internal.h>`
`#include <string.h>`
`#include "dither-impl.h"`
`#include "dither-inlined-functions.h"`

Go to the source code of this file.

## Defines
#define | UPDATE_COLOR(color, dither)
## Functions
int | update_dither (stpi_dither_t *d, int channel, int width, int direction, int *error0, int *error1)
int | print_color (const stpi_dither_t *d, stpi_dither_channel_t *dc, int x, int y, unsigned char bit, int length, int dontprint, int stpi_dither_type, const unsigned char *mask)
int | shared_ed_initializer (stpi_dither_t *d, int row, int duplicate_line, int zero_mask, int length, int direction, int ****error, int **ndither)
void | shared_ed_deinitializer (stpi_dither_t *d, int ***error, int *ndither)
void | stpi_dither_ed (stp_vars_t *v, int row, const unsigned short *raw, int duplicate_line, int zero_mask, const unsigned char *mask)

## Define Documentation

#define UPDATE_COLOR | ( | color,
|  | dither |  | ) |

| Value:
    (                                          \
    ((dither) >= 0)? (color) + ((dither) >> 3) : (color) - ((-(dither)) >> 3))
Definition at line 44 of file dither-ed.c. Referenced by stpi_dither_ed().

## Function Documentation

int print_color | ( | const stpi_dither_t * | d,
|  | stpi_dither_channel_t * | dc,
|  | int | x,
|  | int | y,
|  | unsigned char | bit,
|  | int | length,
|  | int | dontprint,
|  | int | stpi_dither_type,
|  | const unsigned char * | mask
| ) | `[inline, static]`

| Definition at line 123 of file dither-ed.c. References dither::adaptive_limit, dither_channel::b, ink_defn::bits, D_ADAPTIVE_BASE, dither::d_cutoff, D_ORDERED, D_ORDERED_BASE, dither_channel::dithermat, ditherpoint(), dither_segment::is_same_ink, dither_segment::lower, dither_channel::nlevels, dither_channel::o, dither_channel::pick, dither_channel::ptr, dither::ptr_offset, dither_channel::randomizer, ink_defn::range, dither_segment::range_span, dither_channel::ranges, set_row_ends(), stp_dither_matrix_impl_t, stpi_dither_channel_t, stpi_dither_segment_t, stpi_dither_t, stpi_ink_defn_t, dither_segment::upper, dither_channel::v, ink_defn::value, and dither_segment::value_span. Referenced by stpi_dither_ed().

void shared_ed_deinitializer | ( | stpi_dither_t * | d,
|  | int *** | error,
|  | int * | ndither
| ) | `[static]`

| Definition at line 388 of file dither-ed.c. References CHANNEL_COUNT, STP_SAFE_FREE, and stpi_dither_t. Referenced by stpi_dither_ed().

int shared_ed_initializer | ( | stpi_dither_t * | d,
|  | int | row,
|  | int | duplicate_line,
|  | int | zero_mask,
|  | int | length,
|  | int | direction,
|  | int **** | error,
|  | int ** | ndither
| ) | `[static]`

| Definition at line 335 of file dither-ed.c. References CHANNEL, CHANNEL_COUNT, dither::dst_width, dither::error_rows, dither::last_line_was_empty, dither::ptr_offset, stp_malloc(), stpi_dither_get_errline(), and stpi_dither_t. Referenced by stpi_dither_ed().

void stpi_dither_ed | ( | stp_vars_t * | v,
|  | int | row,
|  | const unsigned short * | raw,
|  | int | duplicate_line,
|  | int | zero_mask,
|  | const unsigned char * | mask
| ) |

| Definition at line 402 of file dither-ed.c. References ADVANCE_BIDIRECTIONAL, CHANNEL, CHANNEL_COUNT, D_ADAPTIVE_BASE, dither::dst_width, dither::error_rows, print_color(), shared_ed_deinitializer(), shared_ed_initializer(), dither::src_width, stp_get_component_data(), stp_vars_t, stpi_dither_ordered(), stpi_dither_reverse_row_ends(), stpi_dither_t, dither::stpi_dither_type, UPDATE_COLOR, and update_dither().

int update_dither | ( | stpi_dither_t * | d,
|  | int | channel,
|  | int | width,
|  | int | direction,
|  | int * | error0,
|  | int * | error1
| ) | `[inline, static]`

| Definition at line 55 of file dither-ed.c. References CHANNEL, dither::offset0_table, dither::offset1_table, dither::spread, dither::spread_mask, and stpi_dither_t. Referenced by stpi_dither_ed().